const util = require('util');

myArgs = process.argv.slice(2);

if (typeof myArgs[0] != 'undefined') { 
Env = require("./env-"+myArgs[0]).env;
} else {
Env = require("./env").env;
}


const kavaUtils = require("./lib/utils").utils;

'use strict';

const KavaClient = require('./lib/client').KavaClient;
const tx = require('./lib/tx').tx;
const msg = require('./lib/msg').msg;
const utils = require('./lib/utils').utils;
const crypto = require('./lib/crypto').crypto;

module.exports = {
  KavaClient,
  tx,
  msg,
  utils,
  crypto,
};


const KAVA_CONVERSION_FACTOR = 10 ** 6;
const USDX_CONVERSION_FACTOR = 10 ** 6;
const BTC_CONVERSION_FACTOR = 10 ** 8;
const BNB_CONVERSION_FACTOR = 10 ** 8;
const XRP_CONVERSION_FACTOR = 10 ** 8;

if (typeof Env.KavaAccount.KAVA_REWARD_FACTOR == 'undefined') {
  KAVA_REWARD_FACTOR = 0.70 ;
} else {
  KAVA_REWARD_FACTOR = Env.KavaAccount.KAVA_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.USDX_REWARD_FACTOR == 'undefined') { 
  USDX_REWARD_FACTOR = 0.30 ; 
} else {
  USDX_REWARD_FACTOR = Env.KavaAccount.USDX_REWARD_FACTOR ; 
}

if (typeof Env.KavaAccount.PROGRAMMER_REWARD_FACTOR == 'undefined') {
  PROGRAMMER_REWARD_FACTOR = 0.05; 
} else {
  PROGRAMMER_REWARD_FACTOR = Env.KavaAccount.PROGRAMMER_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.WALLET_RESERVE == 'undefined') {
  WALLET_RESERVE = 0.0101 ; 
} else {
  WALLET_RESERVE = Env.KavaAccount.WALLET_RESERVE; 
}

if (typeof Env.KavaAccount.COMPOUND_LIMIT == 'undefined') {
  COMPOUND_LIMIT = 0.0011 ; // the amount of pending rewards at which we start autocompounding
} else {
  COMPOUND_LIMIT = Env.KavaAccount.COMPOUND_LIMIT ; // the amount of pending rewards at which we start autocompounding
}

if (typeof Env.KavaAccount.GASLIMIT == 'undefined') {
  GASLIMIT = 2000000 ; 
} else {
  GASLIMIT = Env.KavaAccount.GASLIMIT ; 
}

if (typeof Env.KavaAccount.KAVAFEE == 'undefined') {
  KAVAFEE = 0;
} else {
  KAVAFEE = Env.KavaAccount.KAVAFEE;
}

if (typeof Env.KavaAccount.HONOR_PROGRAMMER == 'undefined') {
  HONOR_PROGRAMMER = 1;
} else {
  HONOR_PROGRAMMER = Env.KavaAccount.HONOR_PROGRAMMER ; 
}

if (typeof Env.KavaAccount.PROGRAMMER_ADDR == 'undefined') {
  PROGRAMMER_ADDR = "kava1757uf8nmejhlqnmk99n4d9y78taud4neneutus";
} else {
  PROGRAMMER_ADDR = Env.KavaAccount.PROGRAMMER_ADDR ; 
}



var main = async() => {


    kavaClient = new KavaClient(Env.KavaEndpoints.Mainnet);
    kavaClient.setWallet(Env.KavaAccount.Mainnet.Mnemonic);
    kavaClient.setBroadcastMode("sync");
    await kavaClient.initChain();


    unused_balance = 0;

    console.log("Account:", Env.KavaAccount.Mainnet.Address);
    let balances = await kavaClient.getBalances(Env.KavaAccount.Mainnet.Address,10000);

    let kavaBalance = balances.find((item) => item.denom.toUpperCase() === "UKAVA");
    if(kavaBalance) {
        console.log("\tBalance (kava):", kavaBalance.amount / KAVA_CONVERSION_FACTOR);
        unused_balance = kavaBalance.amount / KAVA_CONVERSION_FACTOR ;
    }

    let kavaDelegations = await kavaClient.getDelegations(Env.KavaAccount.Mainnet.Address);
//console.log(kavaDelegations);
    let staked = 0 ; 
    let validators = [];
    let bal_before = 0; 
    next_val = "";
    for (let element of kavaDelegations) {
      let balance = element.balance; 
      validators.push(element.delegation.validator_address);
        staked = staked + (balance.amount / KAVA_CONVERSION_FACTOR);
        if (bal_before > (balance.amount / KAVA_CONVERSION_FACTOR) ) {
          bal_before = (balance.amount / KAVA_CONVERSION_FACTOR); 
          next_val = element.delegation.validator_address; 
        } else {
        	bal_before = (balance.amount / KAVA_CONVERSION_FACTOR);
        	if (next_val == "") {
        	  next_val = element.delegation.validator_address; 
        	} 
        }
        
    }
    console.log("\tStaked (kava):" , staked) ;
    console.log("\tnext validator: ", next_val); 

/*  
    if (unused_balance > (WALLET_RESERVE + COMPOUND_LIMIT)) { 
      let new_stake_balance = unused_balance - WALLET_RESERVE ; 
      console.log("new staking: ", new_stake_balance);
      denom_val = new_stake_balance * KAVA_CONVERSION_FACTOR;
      denom_val = Math.floor(denom_val);
      denom_val = denom_val.toFixed(0);
        
        let txMsgs = [] ; 
                txMsgs.push ( {
        type: 'cosmos-sdk/MsgDelegate',
        value: {
            delegator_address: Env.KavaAccount.Mainnet.Address,
            validator_address: next_val,
            amount: {denom:'ukava', amount: denom_val.toString() }
        },
    });
console.log("new delegate" , denom_val);
	let txid = await kavaClient.sendTx(txMsgs, fee={amount: [{ denom: 'ukava', amount: String(KAVAFEE) }], gas: String(GASLIMIT)}, null);	
	console.log("stake kava, created TX ", txid) ;

    }
*/


    let kavaRewards = await kavaClient.getDistributionRewards(Env.KavaAccount.Mainnet.Address);

    let Rewards = kavaRewards.total.find((item) => item.denom.toUpperCase() === "UKAVA");
    if(Rewards) {
        console.log("\tStaking Rewards (kava):", Rewards.amount / KAVA_CONVERSION_FACTOR);
    }
    if (Rewards.amount / KAVA_CONVERSION_FACTOR > COMPOUND_LIMIT) { 
        console.log("time to get rewards!");

        let txMsgs = [] ; 
        for (let val of validators) { 
                txMsgs.push ( {
        type: 'cosmos-sdk/MsgWithdrawDelegationReward',
        value: {
            delegator_address: Env.KavaAccount.Mainnet.Address,
            validator_address: val,
        },
    });
        }

// ## Honor the programmer of this little script.

if (HONOR_PROGRAMMER === 1) { 
	denom_val_programmer = Rewards.amount * PROGRAMMER_REWARD_FACTOR; 
	Rewards.amount = Rewards.amount - denom_val_programmer;
	denom_val_programmer = Math.floor(denom_val_programmer);
    denom_val_programmer = denom_val_programmer.toFixed(0);
	                txMsgs.push ( {
        type: 'cosmos-sdk/MsgSend',
        value: {
            from_address: Env.KavaAccount.Mainnet.Address,
            to_address: PROGRAMMER_ADDR,
            amount: [{denom:'ukava', amount: denom_val_programmer.toString() }]
        },
    });
console.log("new transfer programmer" , denom_val_programmer);
}


		// use 75% to restake, swap to USDX from 25% 
		denom_val_stake = Rewards.amount * KAVA_REWARD_FACTOR; 
		denom_val_usdx = Rewards.amount * USDX_REWARD_FACTOR; 
        denom_val = denom_val_stake - KAVAFEE ; 
      denom_val = Math.floor(denom_val);
      denom_val = denom_val.toFixed(0);
  Rewards.amount * KAVA_REWARD_FACTOR; 
                txMsgs.push ( {
        type: 'cosmos-sdk/MsgDelegate',
        value: {
            delegator_address: Env.KavaAccount.Mainnet.Address,
            validator_address: next_val,
            amount: {denom:'ukava', amount: denom_val.toString() }
        },
    });
console.log("new delegate" , denom_val);

// send transactions 
//console.log("all messages" , txMsgs);
console.log(util.inspect(txMsgs, {showHidden: false, depth: null, colors: true}))

	let txid = await kavaClient.sendTx( txMsgs, fee={amount: [{ denom: 'ukava', amount: String(KAVAFEE) }], gas: String(GASLIMIT)} , null);
	console.log("fetched rewards, created TX ", txid) ; 

        
    }

}

main();
