const util = require('util');

myArgs = process.argv.slice(2);

if (typeof myArgs[0] != 'undefined') { 
Env = require("./env-"+myArgs[0]).env;
} else {
Env = require("./env").env;
}

const kavaUtils = require("./lib/utils").utils;

'use strict';

const KavaClient = require('./lib/client').KavaClient;
const tx = require('./lib/tx').tx;
const msg = require('./lib/msg').msg;
const utils = require('./lib/utils').utils;
const crypto = require('./lib/crypto').crypto;

module.exports = {
  KavaClient,
  tx,
  msg,
  utils,
  crypto,
};



const KAVA_CONVERSION_FACTOR = 10 ** 6;

if (typeof Env.KavaAccount.KAVA_REWARD_FACTOR == 'undefined') {
  KAVA_REWARD_FACTOR = 0.70 ;
} else {
  KAVA_REWARD_FACTOR = Env.KavaAccount.KAVA_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.USDX_REWARD_FACTOR == 'undefined') { 
  USDX_REWARD_FACTOR = 0.30 ; 
} else {
  USDX_REWARD_FACTOR = Env.KavaAccount.USDX_REWARD_FACTOR ; 
}

if (typeof Env.KavaAccount.PROGRAMMER_REWARD_FACTOR == 'undefined') {
  PROGRAMMER_REWARD_FACTOR = 0.05; 
} else {
  PROGRAMMER_REWARD_FACTOR = Env.KavaAccount.PROGRAMMER_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.WALLET_RESERVE == 'undefined') {
  WALLET_RESERVE = 0.0101 ; 
} else {
  WALLET_RESERVE = Env.KavaAccount.WALLET_RESERVE; 
}

if (typeof Env.KavaAccount.COMPOUND_LIMIT == 'undefined') {
  COMPOUND_LIMIT = 0.0011 ; // the amount of pending rewards at which we start autocompounding
} else {
  COMPOUND_LIMIT = Env.KavaAccount.COMPOUND_LIMIT ; // the amount of pending rewards at which we start autocompounding
}

if (typeof Env.KavaAccount.GASLIMIT == 'undefined') {
  GASLIMIT = 2000000 ; 
} else {
  GASLIMIT = Env.KavaAccount.GASLIMIT ; 
}

if (typeof Env.KavaAccount.KAVAFEE == 'undefined') {
  KAVAFEE = 1000;
} else {
  KAVAFEE = Env.KavaAccount.KAVAFEE;
}

if (typeof Env.KavaAccount.HONOR_PROGRAMMER == 'undefined') {
  HONOR_PROGRAMMER = 1;
} else {
  HONOR_PROGRAMMER = Env.KavaAccount.HONOR_PROGRAMMER ; 
}



var main = async () => {


    kavaClient = new KavaClient(Env.KavaEndpoints.Mainnet);
    kavaClient.setWallet(Env.KavaAccount.Mainnet.Mnemonic);
    kavaClient.setBroadcastMode("sync");
    await kavaClient.initChain();
    
let claimDelegatorReward = msg.kava.newMsgClaimDelegatorReward(
    Env.KavaAccount.Mainnet.Address,
    [  {denom: 'hard', multiplier_name: 'large'}, {denom: 'swp', multiplier_name: 'large'}]
);

let claimHardReward = msg.kava.newMsgClaimHardReward(
    Env.KavaAccount.Mainnet.Address,
    [  {denom: 'hard', multiplier_name: 'large'}, {denom: 'ukava', multiplier_name: 'large'}]
);

let claimSwapReward = msg.kava.newMsgClaimSwapReward(
    Env.KavaAccount.Mainnet.Address,
    [{denom: 'swp', multiplier_name: 'large'}]
);

Rewards = await kavaClient.sendTx([claimDelegatorReward, claimHardReward, claimSwapReward ], fee={amount: [{denom: 'ukava', amount: String(KAVAFEE)}], gas: String(GASLIMIT)}, null);
    console.log("rewards: ", Rewards);

/*
await new Promise(resolve => setTimeout(resolve, 180000));
await kavaClient.initChain();
Rewards = await kavaClient.sendTx([claimSwapReward], fee={amount: [{denom: 'ukava', amount: String(KAVAFEE)}], gas: String(GASLIMIT)}, null);
    console.log("rewards: ", Rewards);
*/    
}

main();
