const util = require('util');

myArgs = process.argv.slice(2);

if (typeof myArgs[0] != 'undefined') { 
Env = require("./env-"+myArgs[0]).env;
} else {
Env = require("./env").env;
}

const kavaUtils = require("./lib/utils").utils;

'use strict';

const KavaClient = require('./lib/client').KavaClient;
const Swap = require('./lib/client/swap').Swap;
const tx = require('./lib/tx').tx;
const msg = require('./lib/msg').msg;
const utils = require('./lib/utils').utils;
const crypto = require('./lib/crypto').crypto;

module.exports = {
  KavaClient,
  tx,
  msg,
  utils,
  crypto,
  Swap,

};


const KAVA_CONVERSION_FACTOR = 10 ** 6;
const USDX_CONVERSION_FACTOR = 10 ** 6;
const BTC_CONVERSION_FACTOR = 10 ** 8;
const BNB_CONVERSION_FACTOR = 10 ** 8;
const XRP_CONVERSION_FACTOR = 10 ** 8;
const XRPB_CONVERSION_FACTOR = 10 ** 8;
const BUSD_CONVERSION_FACTOR = 10 ** 8;
const BTCB_CONVERSION_FACTOR = 10 ** 8;
const ATOM_CONVERSION_FACTOR = 10 ** 6; 
const AKT_CONVERSION_FACTOR = 10 ** 6 ; 
const OSMOSIS_CONVERSION_FACTOR = 10 ** 6;



if (typeof Env.KavaAccount.KAVA_REWARD_FACTOR == 'undefined') {
  KAVA_REWARD_FACTOR = 0.70 ;
} else {
  KAVA_REWARD_FACTOR = Env.KavaAccount.KAVA_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.USDX_REWARD_FACTOR == 'undefined') { 
  USDX_REWARD_FACTOR = 0.30 ; 
} else {
  USDX_REWARD_FACTOR = Env.KavaAccount.USDX_REWARD_FACTOR ; 
}

if (typeof Env.KavaAccount.PROGRAMMER_REWARD_FACTOR == 'undefined') {
  PROGRAMMER_REWARD_FACTOR = 0.05; 
} else {
  PROGRAMMER_REWARD_FACTOR = Env.KavaAccount.PROGRAMMER_REWARD_FACTOR; 
}

if (typeof Env.KavaAccount.PROGRAMMER_ADDR == 'undefined') {
  PROGRAMMER_ADDR = "kava1757uf8nmejhlqnmk99n4d9y78taud4neneutus"; 
} else {
  PROGRAMMER_ADDR = Env.KavaAccount.PROGRAMMER_ADDR; 
}



if (typeof Env.KavaAccount.WALLET_RESERVE == 'undefined') {
  WALLET_RESERVE = 0.0101 ; 
} else {
  WALLET_RESERVE = Env.KavaAccount.WALLET_RESERVE; 
}

if (typeof Env.KavaAccount.COMPOUND_LIMIT == 'undefined') {
  COMPOUND_LIMIT = 0.0011 ; // the amount of pending rewards at which we start autocompounding
} else {
  COMPOUND_LIMIT = Env.KavaAccount.COMPOUND_LIMIT ; // the amount of pending rewards at which we start autocompounding
}

if (typeof Env.KavaAccount.GASLIMIT == 'undefined') {
  GASLIMIT = 2000000 ; 
} else {
  GASLIMIT = Env.KavaAccount.GASLIMIT ; 
}

if (typeof Env.KavaAccount.KAVAFEE == 'undefined') {
  KAVAFEE = 1000;
} else {
  KAVAFEE = Env.KavaAccount.KAVAFEE;
}

if (typeof Env.KavaAccount.HONOR_PROGRAMMER == 'undefined') {
  HONOR_PROGRAMMER = 1;
} else {
  HONOR_PROGRAMMER = Env.KavaAccount.HONOR_PROGRAMMER ; 
}

if (typeof Env.KavaAccount.AUTOSWAP_COINS == 'undefined') {
  AUTOSWAP_COINS = [ "USDX" ] ;
} else {
  AUTOSWAP_COINS = Env.KavaAccount.AUTOSWAP_COINS ; 
}

if (typeof Env.KavaAccount.AUTOSWAP_POOLS == 'undefined') {
  AUTOSWAP_POOLS = [ "BTCUSDX" ] ;
} else {
  AUTOSWAP_POOLS = Env.KavaAccount.AUTOSWAP_POOLS ; 
}



var main = async () => {


    kavaClient = new KavaClient(Env.KavaEndpoints.Mainnet);
    kavaClient.setWallet(Env.KavaAccount.Mainnet.Mnemonic);
    kavaClient.setBroadcastMode("sync");
    await kavaClient.initChain();
    swap = new Swap(kavaClient);



    unused_balance = 0;

    console.log("Account:", Env.KavaAccount.Mainnet.Address);
    let balances = await kavaClient.getBalances(Env.KavaAccount.Mainnet.Address,10000);

    let kavaBalance = balances.find((item) => item.denom.toUpperCase() === "UKAVA");
    if(kavaBalance) {
        console.log("\tBalance (kava):", kavaBalance.amount / KAVA_CONVERSION_FACTOR);
        unused_balance = kavaBalance.amount / KAVA_CONVERSION_FACTOR ;
    }

    let kavaDelegations = await kavaClient.getDelegations(Env.KavaAccount.Mainnet.Address);
    let staked = 0 ; 
    let validators = [];
    let bal_before = 0; 
    next_val = "";
    for (let element of kavaDelegations) {
      let balance = element.balance; 
      validators.push(element.validator_address);
        staked = staked + (balance.amount / KAVA_CONVERSION_FACTOR);
        if (bal_before > (balance.amount / KAVA_CONVERSION_FACTOR) ) {
          bal_before = (balance.amount / KAVA_CONVERSION_FACTOR); 
          next_val = element.validator_address; 
        } else {
        	bal_before = (balance.amount / KAVA_CONVERSION_FACTOR);
        	if (next_val == "") {
        	  next_val = element.validator_address; 
        	} 
        }
        
    }

  
    if (unused_balance > (WALLET_RESERVE)) { 


let txMsgs = []; 
// ############# GET PRICES FROM POOLS FOR SWAPPING!

	let markets = await swap.getPools();
	console.log("markets: ",markets);
	for (let market of markets) {
	 if (market.name == "busd:usdx") {  
		busd_usdx_market = market.coins ; 
		busd_usdx_shares = market.total_shares;
		}
	if (market.name == "ukava:usdx") {  
		ukava_usdx_market = market.coins ; 
		ukava_usdx_shares = market.total_shares;
		}
	if (market.name == "bnb:usdx") {  
		bnb_usdx_market = market.coins ; 
		bnb_usdx_shares = market.total_shares;
		}
	if (market.name == "btcb:usdx") {  
		btcb_usdx_market = market.coins ; 
		btcb_usdx_shares = market.total_shares;
		}
	if (market.name == "usdx:xrpb") {  
		xrpb_usdx_market = market.coins ; 
		xrpb_usdx_shares = market.total_shares;
		}								

	if (market.name == "ibc/0471F1C4E7AFD3F07702BEF6DC365268D64570F7C1FDC98EA6098DD6DE59817B:usdx") {
          // OSMOSIS
                osmosis_usdx_market = market.coins ; 
                osmosis_usdx_shares = market.total_shares;
	}
	if (market.name == "ibc/27394FB092D2ECCD56123C74F36E4C1F926001CEADA9CA97EA622B25F41E5EB2:usdx") { 
	  // ATOM!!
	        atom_usdx_market = market.coins ; 
	        atom_usdx_shares = market.total_shares;
	}
	if (market.name == "ibc/799FDD409719A1122586A629AE8FCA17380351A51C1F47A80A1B8E7F2A491098:usdx") { 
          // AKT!!
                akt_usdx_market = market.coins ; 
                akt_usdx_shares = market.total_shares;
	}
	if (market.name == "ibc/B448C0CA358B958301D328CCDC5D5AD642FC30A6D3AE106FF721DB315F3DDE5C:usdx") { 
	
	}
	if (market.name == "ibc/B8AF5D92165F35AB31F3FC7C7B444B9D240760FA5D406C49D24862BD0284E395:usdx") { 
	
	}
	}
	console.log("coins ",busd_usdx_market);
	console.log("shares ",busd_usdx_shares);
	
	price_in_busd = (busd_usdx_market[0].amount * USDX_CONVERSION_FACTOR) / (busd_usdx_market[1].amount * BUSD_CONVERSION_FACTOR);
	console.log("price ", price_in_busd ) ;
	
	const busdvaluation = await kavaClient.getPrice("usdx:usd");
	console.log("price getprice ",  busdvaluation);



	console.log("coins ",bnb_usdx_market);
	console.log("shares ",bnb_usdx_shares);

	price_in_bnb = (bnb_usdx_market[1].amount * BNB_CONVERSION_FACTOR) / (bnb_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_bnb ) ;
	
	const bnbvaluation = await kavaClient.getPrice("bnb:usd");
	console.log("price getprice ",  bnbvaluation);	
	



	
	console.log("coins ",ukava_usdx_market);
	console.log("shares ",ukava_usdx_shares);

	price_in_kava= (ukava_usdx_market[1].amount * KAVA_CONVERSION_FACTOR) / (ukava_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_kava ) ;
	
	const ukavavaluation = await kavaClient.getPrice("kava:usd");
	console.log("price getprice ",  ukavavaluation);	

		


	
	console.log("coins ",btcb_usdx_market);
	console.log("shares ",btcb_usdx_shares);

	price_in_btc = (btcb_usdx_market[1].amount * BTCB_CONVERSION_FACTOR) / (btcb_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_btc ) ;
	
	const btcvaluation = await kavaClient.getPrice("btc:usd");
	console.log("price getprice ",  btcvaluation);	



	console.log("coins ",osmosis_usdx_market);
	console.log("shares ",osmosis_usdx_shares);

	price_in_osmosis = (osmosis_usdx_market[1].amount * OSMOSIS_CONVERSION_FACTOR) / (osmosis_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_btc ) ;
	
//	const osmosisvaluation = await kavaClient.getPrice("uosmosis:usd");
//	console.log("price getprice ",  osmosisvaluation);	



	console.log("coins ",atom_usdx_market);
	console.log("shares ",atom_usdx_shares);

	price_in_atom = (atom_usdx_market[1].amount * ATOM_CONVERSION_FACTOR) / (atom_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_btc ) ;
	
	const atomvaluation = await kavaClient.getPrice("atom:usd");
	console.log("price getprice ",  atomvaluation);	


	console.log("coins ",akt_usdx_market);
	console.log("shares ",akt_usdx_shares);

	price_in_akt = (akt_usdx_market[1].amount * AKT_CONVERSION_FACTOR) / (akt_usdx_market[0].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_btc ) ;
	
	const aktvaluation = await kavaClient.getPrice("akt:usd");
	console.log("price getprice ",  aktvaluation);	




	console.log("coins ",xrpb_usdx_market);
	console.log("shares ",xrpb_usdx_shares);

	price_in_xrp = (xrpb_usdx_market[0].amount * XRPB_CONVERSION_FACTOR) / (xrpb_usdx_market[1].amount * USDX_CONVERSION_FACTOR);
	console.log("price ", price_in_xrp ) ;
	
	const xrpvaluation = await kavaClient.getPrice("xrp:usd");
	console.log("price getprice ",  xrpvaluation);	



// ############# END GET PRICES FROM POOLS FOR SWAPPING!


swap_balance = unused_balance - WALLET_RESERVE; 
console.log("swap balance: ", swap_balance) ;
		// use 75% to restake, swap to USDX from 25% 
		denom_val_usdx = swap_balance - KAVAFEE;

      denom_val_usdx = swap_balance * KAVA_CONVERSION_FACTOR ; 
      denom_val_usdx = Math.floor(denom_val_usdx);
      denom_val_usdx = denom_val_usdx.toFixed(0);


// ######### KAVA to USDX 

    // Attempt a swap to a valid tradable pool with an exact tokenA
    // coins to deposit to the pool
//const usdxValuation = await kavaClient.getPrice("kava:usd");
const usdxValuation = price_in_kava;

console.log("KAVA Price USDX: ", usdxValuation);
    const exactTokenA = kavaUtils.formatCoin(denom_val_usdx, "ukava");
    // coins to withdraw from the pool
usdx_val = (denom_val_usdx / KAVA_CONVERSION_FACTOR )* usdxValuation  ; 
usdx_val = usdx_val.toFixed(6);
usdx_val = usdx_val * USDX_CONVERSION_FACTOR;
usdx_val = usdx_val.toFixed(0);

    const tokenB = kavaUtils.formatCoin( usdx_val, "usdx");
    slippage = "0.025000000000000000";
    const deadline = String(Math.floor(Date.now() / 1000) + 300); 

console.log("swapping KAVA: ", denom_val_usdx / KAVA_CONVERSION_FACTOR);
console.log(exactTokenA);
console.log("to USDX: ", (denom_val_usdx / KAVA_CONVERSION_FACTOR )* usdxValuation);
console.log(tokenB);

    const msgSwapExactForTokens = msg.swap.newMsgSwapExactForTokens(
      Env.KavaAccount.Mainnet.Address,
      exactTokenA,
      tokenB,
      slippage,
      deadline
    );
    console.log("Swap Exact For tx:", msgSwapExactForTokens);
	//swapmsg = msgSwapExactForTokens.shift; 
txMsgs.push ( msgSwapExactForTokens );



// ############# USDX to BTC 

    // Attempt a swap to a valid tradable pool with an exact tokenA
    // coins to deposit to the pool
//const btcValuation = await kavaClient.getPrice("btc:usd");
const btcValuation = price_in_btc ; 
console.log("BTC Price USDX: ", btcValuation);
usd_amount = ( denom_val_usdx / KAVA_CONVERSION_FACTOR ) * usdxValuation / 4; 
usd_amount = usd_amount.toFixed(6);
usd_amount = usd_amount * USDX_CONVERSION_FACTOR;
usd_amount = usd_amount.toFixed(0);
    const exactTokenA_BTC = kavaUtils.formatCoin(usd_amount , "usdx");
    // coins to withdraw from the pool
btc_val = (usd_amount / USDX_CONVERSION_FACTOR ) / btcValuation  ; 
btc_val = btc_val.toFixed(8);
btc_val = btc_val * BTC_CONVERSION_FACTOR;
btc_val = btc_val.toFixed(0);
    const tokenB_BTC = kavaUtils.formatCoin( btc_val, "btcb");
    slippage = "0.025000000000000000";

     

console.log("swapping USDX: ", usd_amount / USDX_CONVERSION_FACTOR);
console.log(exactTokenA_BTC);
console.log("to BTC: ", btc_val);
console.log(tokenB_BTC);
calc_price = btc_val*btcValuation; 
console.log("price BTC: ", calc_price);
console.log("difference: ", calc_price - usd_amount);
console.log("slippage:",  1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ) ;
		slippage = 1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ; 
		slippage = String(slippage);
slippage = "1.000000000000000000";

    const msgSwapExactForTokensBTC = msg.swap.newMsgSwapForExactTokens(
      Env.KavaAccount.Mainnet.Address,
      exactTokenA_BTC,
      tokenB_BTC,
      slippage,
      deadline
    );
    console.log("Swap Exact For tx:", msgSwapExactForTokensBTC);
txMsgs.push ( msgSwapExactForTokensBTC );


// ############# USDX to BNB 

    // Attempt a swap to a valid tradable pool with an exact tokenA
    // coins to deposit to the pool
//const bnbValuation = await kavaClient.getPrice("bnb:usd");
const bnbValuation = price_in_bnb;
console.log("BNB Price USDX: ", bnbValuation);
usd_amount = ( denom_val_usdx / KAVA_CONVERSION_FACTOR ) * usdxValuation / 4; 
usd_amount = usd_amount.toFixed(6);
usd_amount = usd_amount * USDX_CONVERSION_FACTOR;
usd_amount = usd_amount.toFixed(0);

    const exactTokenA_BNB = kavaUtils.formatCoin(usd_amount , "usdx");
    // coins to withdraw from the pool
bnb_val = (usd_amount / USDX_CONVERSION_FACTOR ) / bnbValuation  ; 
bnb_val = bnb_val.toFixed(8);
bnb_val = bnb_val * BNB_CONVERSION_FACTOR;
bnb_val = bnb_val.toFixed(0);
    const tokenB_BNB = kavaUtils.formatCoin( bnb_val, "bnb");
    slippage = "0.025000000000000000";
     

console.log("swapping USDX: ", usd_amount / USDX_CONVERSION_FACTOR);
console.log(exactTokenA_BNB);
console.log("to BNB: ", bnb_val);
console.log(tokenB_BNB);

    const msgSwapExactForTokensBNB = msg.swap.newMsgSwapForExactTokens(
      Env.KavaAccount.Mainnet.Address,
      exactTokenA_BNB,
      tokenB_BNB,
      slippage,
      deadline
    );
    console.log("Swap Exact For tx:", msgSwapExactForTokensBNB);
txMsgs.push ( msgSwapExactForTokensBNB );

// ############# USDX to XRP 

    // Attempt a swap to a valid tradable pool with an exact tokenA
    // coins to deposit to the pool
//const bnbValuation = await kavaClient.getPrice("xrp:usd");
const xrpValuation = price_in_xrp; 
console.log("XRP Price USDX: ", xrpValuation);
usd_amount = ( denom_val_usdx / KAVA_CONVERSION_FACTOR ) * usdxValuation / 4; 
usd_amount = usd_amount.toFixed(6);
usd_amount = usd_amount * USDX_CONVERSION_FACTOR;
usd_amount = usd_amount.toFixed(0);

    const exactTokenA_XRP = kavaUtils.formatCoin(usd_amount , "usdx");
    // coins to withdraw from the pool
xrp_val = (usd_amount / USDX_CONVERSION_FACTOR ) / xrpValuation  ; 
xrp_val = xrp_val.toFixed(8);
xrp_val = xrp_val * XRP_CONVERSION_FACTOR;
xrp_val = xrp_val.toFixed(0);
    const tokenB_XRP = kavaUtils.formatCoin( xrp_val, "xrpb");
    slippage = "0.025000000000000000";
     

console.log("swapping USDX: ", usd_amount / USDX_CONVERSION_FACTOR);
console.log(exactTokenA_XRP);
console.log("to XRP: ", xrp_val);
console.log(tokenB_XRP);

    const msgSwapExactForTokensXRP = msg.swap.newMsgSwapForExactTokens(
      Env.KavaAccount.Mainnet.Address,
      exactTokenA_XRP,
      tokenB_XRP,
      slippage,
      deadline
    );
    console.log("Swap Exact For tx:", msgSwapExactForTokensXRP);
txMsgs.push ( msgSwapExactForTokensXRP );


//  ########## add BTC and USDX to Liquidity Pool


if (btc_val > 2) { 
	btc_val = btc_val - 1 ;

calc_price = btc_val*btcValuation; 
console.log("price BTC: ", calc_price);
console.log("difference: ", calc_price - usd_amount);
console.log("slippage:",  1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ) ;
slippage = 1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ; 
usd_amount_btc = (btc_val * btcValuation / (1+ slippage)) / BTC_CONVERSION_FACTOR;
usd_amount_btc = usd_amount_btc * USDX_CONVERSION_FACTOR; 
usd_amount_btc = usd_amount_btc.toFixed(0);
slippage = String(slippage);

    // deposit coins to the swap bnb:usdx pool
    const tokenA = kavaUtils.formatCoin(btc_val, "btcb");
    const tokenB = kavaUtils.formatCoin(usd_amount_btc, "usdx");
    slippage = "0.330000000000000000";

calc_price = btc_val*btcValuation; 
console.log("price BTC: ", calc_price);
console.log("difference: ", calc_price - usd_amount);
console.log("slippage:",  1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ) ;
slippage = 1 - ( (calc_price -  usd_amount ) / (btc_val*btcValuation) ) ; 
slippage = String(slippage);
    slippage = "1.000000000000000000";

    // create a deadline of 30 seconds from now for the max amount of time to wait
    // for the transaction to be processed
     
    const msgDeposit = msg.swap.newMsgDeposit(
      Env.KavaAccount.Mainnet.Address,
      tokenA,
      tokenB,
      slippage, 
      deadline
    );
txMsgs.push ( msgDeposit );
    console.log("Swap BTCB/USDX:", msgDeposit);

}


// ####### add BNB and XRP to Lending
bnb_val_lend = bnb_val * 0.975 ; // slippage
bnb_val_lend = bnb_val_lend.toFixed(0); 
bnb_lend = kavaUtils.formatCoins(bnb_val , "bnb");
    const msgDepositBNB = msg.hard.newMsgDeposit(
      Env.KavaAccount.Mainnet.Address,
      bnb_lend
    );
txMsgs.push ( msgDepositBNB );
    console.log("Lend BNB:", msgDepositBNB);

xrp_val_lend = xrp_val * 0.975 ; // slippage
xrp_val_lend = xrp_val_lend.toFixed(0);
xrp_lend = kavaUtils.formatCoins(xrp_val , "xrpb");
    const msgDepositXRP = msg.hard.newMsgDeposit(
      Env.KavaAccount.Mainnet.Address,
      xrp_lend
    );
txMsgs.push ( msgDepositXRP );
    console.log("Lend XRP:", msgDepositXRP);


// send transactions 
console.log("all messages" , txMsgs);
	let txid = await kavaClient.sendTx( txMsgs, fee={amount: [{ denom: 'ukava', amount: String(KAVAFEE) }], gas: String(GASLIMIT)}, null);
	console.log("fetched rewards, created TX ", txid) ; 

        

}

}

main();
